on printText textString
  if the machineType = 256 then
    set printingFont to "arial"
    openXLib("pmatic.dll")
    set printer to pmatic(mnew)
    printer(mRegister, "10049757-547")
  else
    set printingFont to "helvetica"
    set printer to PrintOMatic(mnew)
    printer(mRegister, "11003142-416")
  end if
  if not objectp(printer) then
    alert("There is no currently selected printer. Printing features are disabled.")
  else
    printer(mSetMargins, 72, 72, 72, 72)
    set w to printer(mGetPageWidth)
    set h to printer(mGetPageHeight)
    printer(mSetTextFont, printingFont)
    printer(mSetTextSize, 10)
    printer(mSetTextStyle, "normal")
    printer(mSetDocumentName, "History of the White House Text")
    set charsPrinted to 0
    repeat while charsPrinted < the number of chars in textString
      printer(mNewPage)
      printer(mTextBox, 0, 0, w, h, 0)
      set charsPrinted to charsPrinted + printer(mSetText, char charsPrinted + 1 to the number of chars in textString of textString)
    end repeat
    printer(mPrint)
    printer(mdispose)
  end if
  if the machineType = 256 then
    closeXLib("pmatic.dll")
  else
  end if
end
